VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "ClearCheck MICR VB Example"
   ClientHeight    =   7905
   ClientLeft      =   1560
   ClientTop       =   1770
   ClientWidth     =   13365
   DrawStyle       =   5  'Transparent
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   7905
   ScaleWidth      =   13365
   Begin CcMicrExampleVB.ctrlImage ctrlImage1 
      Height          =   1095
      Left            =   6480
      TabIndex        =   11
      Top             =   1200
      Width           =   975
      _ExtentX        =   1720
      _ExtentY        =   1931
   End
   Begin VB.Frame frameOptions 
      BorderStyle     =   0  'None
      Height          =   3015
      Left            =   9120
      TabIndex        =   3
      Top             =   120
      Width           =   4095
      Begin VB.Frame Frame4 
         Caption         =   "Extract Check Image Parameters"
         Height          =   540
         Left            =   120
         TabIndex        =   10
         Top             =   1875
         Width           =   3794
         Begin VB.CheckBox chkNoExtractDeskew 
            Caption         =   "Do not Deskew"
            Height          =   182
            Left            =   126
            TabIndex        =   2
            Top             =   240
            Width           =   1778
         End
      End
      Begin VB.Frame Frame3 
         Caption         =   "Read MICR Parameters"
         Height          =   1526
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   3794
         Begin VB.CheckBox chkEnforceAbaParsing 
            Caption         =   "Enforce ABA Format Rules"
            Height          =   255
            Left            =   126
            TabIndex        =   7
            Top             =   252
            Width           =   2775
         End
         Begin VB.TextBox txtMicrToRead_ 
            Height          =   285
            Left            =   1330
            TabIndex        =   6
            Text            =   "1"
            Top             =   630
            Width           =   735
         End
         Begin VB.CheckBox chkExtMicrSearch 
            Caption         =   "Extended MICR Search (unknow resolution, check on IRD, etc.)"
            Height          =   378
            Left            =   126
            TabIndex        =   5
            Top             =   1008
            Width           =   3416
         End
         Begin VB.Label Label1 
            Caption         =   "MICR To read: "
            Height          =   252
            Left            =   126
            TabIndex        =   9
            Top             =   630
            Width           =   1092
         End
         Begin VB.Label Label2 
            Caption         =   "(0 - read all)"
            Height          =   252
            Left            =   2282
            TabIndex        =   8
            Top             =   630
            Width           =   1456
         End
      End
   End
   Begin VB.TextBox txtLastFileName_ 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   4920
      Visible         =   0   'False
      Width           =   3855
   End
   Begin VB.TextBox txtResult 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2055
      Left            =   360
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   2040
      Width           =   4935
   End
   Begin VB.Menu mnuFileOpen 
      Caption         =   "&Open..."
   End
   Begin VB.Menu mnuQuickStart 
      Caption         =   "ReadOneMICR"
   End
   Begin VB.Menu mnuReadMicr 
      Caption         =   "FindMICR"
   End
   Begin VB.Menu mnuExtractCheck 
      Caption         =   "ExtractCheck"
   End
   Begin VB.Menu mnuExtractCheckTop 
      Caption         =   "ExtractCheckTop"
      Visible         =   0   'False
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'===================================================================
' This file is provided as part of the ClearCheck MICR Development Kit
'
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT
' WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
' OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR PURPOSE.
'
' Copyright (C) 2003-2007.  Inlite Research, Inc. All rights reserved
'===================================================================

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  SaveConfig
End Sub

Private Sub mnuExtractCheck_Click()
On Error GoTo DoError
    ' Clear Results
  Me.txtResult.Text = ""
  DoEvents
    '  Read all MICR
  Dim reader As New clsMicrRead
  
  Dim oImage As CiImage
  Set oImage = reader.ExtractFromFile(txtLastFileName_.Text, 1)
  If (Not oImage Is Nothing) Then
    ctrlImage1.oImage.Close
    ctrlImage1.CloseImage
    Set ctrlImage1.oImage = oImage
    ShowImage
    Me.txtResult = reader.ExtractText + vbCrLf + vbCrLf + reader.AllMicrText
  Else
    FileOpen (txtLastFileName_.Text)
    Me.txtResult = "NO MICR"
  End If
  Exit Sub
DoError:
  ShowError
End Sub

Private Sub mnuExtractCheckTop_Click()
On Error GoTo DoError
    ' Clear Results
  Me.txtResult.Text = ""
  DoEvents
    '  Read all MICR
  Dim reader As New clsMicrRead
  
  Dim oImage As CiImage
  Set oImage = reader.ExtractFromFileTop(txtLastFileName_.Text, 1)
  If (Not oImage Is Nothing) Then
    ctrlImage1.oImage.Close
    ctrlImage1.CloseImage
    Set ctrlImage1.oImage = oImage
    ShowImage
    Me.txtResult = reader.AllMicrText
  Else
    FileOpen (txtLastFileName_.Text)
    Me.txtResult = "NO MICR"
  End If
  Exit Sub
DoError:
  ShowError
End Sub


' This shows the basic steps to find MICR and obtain MICR information
Private Function ReadOneMicr(file As String, page As Integer) As String
  Dim out As String
  Dim MicrReader As New CcMicrReader
  MicrReader.Image.Open file, 1
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkEnforceAbaParsing = 0, 0, emrfEnforceAbaParsing)
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkExtMicrSearch = 0, 0, emrfExtendedMicrSearch)
  If (IsNumeric(frmMain.txtMicrToRead_)) Then MicrReader.MaxMicrCount = CInt(frmMain.txtMicrToRead_)
  MicrReader.FindMICR
  If (MicrReader.MicrCount > 0) Then
    Dim micr As CcMicr: Set micr = MicrReader.MicrLine(1)
    out = out + "MICR Type: " + micr.DocumentType + vbCrLf
    out = out + "MICR ANSI: " + micr.info.TextANSI + vbCrLf
    out = out + "MICR RAW : " + micr.info.TextRaw + vbCrLf
    out = out + "MICR PACK: " + micr.info.TextPacked + vbCrLf
    If (micr.Routing.IsRead) Then out = out + "Routing = " & micr.Routing.TextANSI + vbCrLf
    If (micr.RoutingChecksum.IsRead) Then out = out + "RoutingChecksum = " & micr.RoutingChecksum.TextANSI + vbCrLf
    If (micr.AuxOnUs.IsRead) Then out = out + "AuxOnUs = " & micr.AuxOnUs.TextANSI + vbCrLf
    If (micr.OnUs.IsRead) Then out = out + "OnUs = " & micr.OnUs.TextANSI + vbCrLf
    If (micr.Amount.IsRead) Then out = out + "Amount = " & micr.Amount.TextANSI + vbCrLf
    If (micr.Account.IsRead) Then out = out + "Account = " & micr.Account.TextANSI + vbCrLf
    If (micr.CheckNumber.IsRead) Then out = out + "CheckNumber = " & micr.CheckNumber.TextANSI + vbCrLf
  Else
      out = "No MICR found"
  End If
  ReadOneMicr = out
End Function

Private Sub mnuQuickStart_Click()
  Me.txtResult = "": DoEvents
  ' This shows the basic steps to find MICR and obtain MICR information
  Me.txtResult = ReadOneMicr(Me.txtLastFileName_, 1)
End Sub

Private Sub mnuReadMicr_Click()
On Error GoTo DoError
    ' Clear Results
  Me.txtResult.Text = ""
  DoEvents
  Dim reader As New clsMicrRead
  Dim cnt As Integer
  ' cnt = reader.ReadFile(txtLastFileName_.Text, 1)
  cnt = reader.Read(ctrlImage1.oImage)
  If (cnt > 0) Then
    Me.txtResult = reader.AllMicrText
  Else
    ShowImage
    Me.txtResult = "NO MICR"
  End If
  Exit Sub
DoError:
  ShowError
End Sub

Private Sub FileOpen(sFileName)
    If (sFileName = "") Then Exit Sub
    On Error GoTo DoError
    txtLastFileName_.Text = sFileName
    ctrlImage1.oImage.Close
    ctrlImage1.CloseImage
    ctrlImage1.oImage.Open sFileName, 1
    ShowImage
    SaveConfig
    Exit Sub
DoError:
  ShowError "File Open"
End Sub

Private Sub Form_Load()
  On Error GoTo DoExit
  LoadConfig
  FileOpen txtLastFileName_.Text   '  OPEN lats file
  Exit Sub
DoExit:
  ShowError
  End
End Sub

Private Sub Form_Resize()
 If frmMain.WindowState = 1 Or _
          frmMain.ScaleWidth < 1 Or _
          frmMain.ScaleHeight < 1 Then
      Exit Sub
  End If
  
  If (Me.Left < 0) Then Me.Left = 0
  ctrlImage1.Top = 0:  ctrlImage1.Left = 0
  ctrlImage1.Height = Me.ScaleWidth * 2.5 / 8#
  ctrlImage1.Width = Me.ScaleWidth - frameOptions.Width
  frameOptions.Left = ctrlImage1.Width
  frameOptions.Top = ctrlImage1.Top
  txtResult.Top = ctrlImage1.Top + ctrlImage1.Height
  txtResult.Left = 0
  txtResult.Height = Me.ScaleHeight - txtResult.Top
  txtResult.Width = ctrlImage1.Width
End Sub


Private Sub SaveConfig()
  SaveSettings Me
End Sub

Private Sub LoadConfig()
  LoadSettings Me
End Sub

Private Sub mnuFileOpen_Click()
  On Error GoTo except
  Dim sFileName As String
  sFileName = FileOpenDialog(txtLastFileName_.Text)
  sFileName = StripNulls(sFileName)
  If (sFileName <> "") Then
    FileOpen sFileName
  End If
  Exit Sub
except: ShowError "FileOpen"
End Sub

Public Sub ShowImage()
  On Error GoTo except
  ctrlImage1.UpdateImage
  If (ctrlImage1.oImage.IsValid = ciTrue) Then
    If (ctrlImage1.oImage.FileName <> "") Then
      Me.Caption = App.Title & ": " & ctrlImage1.oImage.FileName & "   Page: " & ctrlImage1.oImage.PageNumber
    Else
      Me.Caption = App.Title & " (unnamed)"
    End If
  End If
  Exit Sub
except: ShowError "ShowImage"
End Sub





