VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMicrRead"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private MicrReader As CcMicrReader

Private Sub Class_Initialize()
  Set MicrReader = New CcMicrReader
End Sub


Public Function ReadFile(sFileName As String, nPage As Integer) As Integer
  MicrReader.Image.Open sFileName, nPage
  ReadFile = Read(MicrReader.Image)
End Function


Public Function Read(Image As CiImage) As Integer
  Read = 0
  Set MicrReader = New CcMicrReader
  Set MicrReader.Image = Image
    ' Parameters ===============================
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkEnforceAbaParsing = 0, 0, emrfEnforceAbaParsing)
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkExtMicrSearch = 0, 0, emrfExtendedMicrSearch)
  If (IsNumeric(frmMain.txtMicrToRead_)) Then MicrReader.MaxMicrCount = CInt(frmMain.txtMicrToRead_)
    ' Do actual reading ===============================
  Read = MicrReader.FindMICR
End Function

Public Function ExtractFromFile(sFileName As String, nPage As Integer) As CiImage
  Set MicrReader = New CcMicrReader
  MicrReader.Image.Open sFileName, nPage
    ' Parameters ===============================
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkEnforceAbaParsing = 0, 0, emrfEnforceAbaParsing)
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkExtMicrSearch = 0, 0, emrfExtendedMicrSearch)
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkNoExtractDeskew = 0, 0, emrfNoExtractDeskew)
    ' Do extract reading ===============================
  Set ExtractFromFile = MicrReader.ExtractCheck
End Function

Public Function ExtractFromFileTop(sFileName As String, nPage As Integer) As CiImage
  Set MicrReader = New CcMicrReader
  MicrReader.Image.Open sFileName, nPage
    ' Parameters ===============================
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkNoExtractDeskew = 0, 0, emrfNoExtractDeskew)
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkEnforceAbaParsing = 0, 0, emrfEnforceAbaParsing)
  MicrReader.flags = MicrReader.flags Or IIf(frmMain.chkExtMicrSearch = 0, 0, emrfExtendedMicrSearch)
  MicrReader.MaxMicrCount = 0
    ' Find MICR ===============================
  MicrReader.FindMICR
    ' Do extract reading ===============================
  Set ExtractFromFileTop = MicrReader.ExtractCheckToMicr(MicrReader.MicrCount)
End Function

Public Function FieldInfoText(info As CcMicrInfo) As String
  FieldInfoText = ""
  FieldInfoText = FieldInfoText + info.Name + Space(15 - Len(info.Name))
  FieldInfoText = FieldInfoText + "  " + IIf(info.IsAbaCompliant, "ABA", "   ")
  FieldInfoText = FieldInfoText + " = " + IIf(info.IsFound, info.Text(emtfX37), "NOT PRESENT")
End Function

Public Function AllFieldsInfoText(nMicr As Long) As String
  If (MicrReader.MicrCount) < nMicr Then Exit Function
  Dim oMicr As CcMicr
  Set oMicr = MicrReader.MicrLine(nMicr)
    ' Full MICR string
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.info) + vbCrLf
    ' Individual fields
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.AuxOnUs) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.CheckNumber) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.EPC) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.Routing) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.RoutingChecksum) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.OnUs) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.Account) + vbCrLf
  AllFieldsInfoText = AllFieldsInfoText + Me.FieldInfoText(oMicr.Amount) + vbCrLf
End Function

Public Function AllMicrText() As String
  AllMicrText = ""
  Dim nMicr As Long
  For nMicr = 1 To MicrReader.MicrCount
    AllMicrText = AllMicrText & "MICR#" & CStr(nMicr) & "   Type:" & MicrReader.MicrLine(nMicr).DocumentType & "   -----------------" & vbCrLf & AllFieldsInfoText(nMicr) & vbCrLf
  Next
End Function

Public Function ExtractText() As String
    Dim stext As String
    If (MicrReader.MicrCount = 0) Then Exit Function
    stext = "Extracted Check." + vbCrLf
    stext = stext + "Rect: " + RectToString(MicrReader.MicrLine(1).Document) + vbCrLf
    stext = stext + "Skew: " + Format(MicrReader.MicrLine(1).Document.Skew, "#.##") + "deg"
    stext = stext + "  Rotation: " + Choose(MicrReader.MicrLine(1).Document.Conf, "None", "Upside Down", "Left", "Right", "Unknown")
    ExtractText = stext
End Function

